package com.zswl.cloud.springBatch.client.model.dfy.Hotel.request;

import com.zhongshu.payment.client.type.Channel;
import com.zswl.cloud.springBatch.client.model.dfy.DfyBaseData;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.List;

@Data
@NoArgsConstructor
@AllArgsConstructor
public class AddOrderRequest extends DfyBaseData {

    @NotNull
    private Channel channel;
    private String sourceOrderId; // 分销商订单号
    private String acctId; // 账号Id
    @NotNull
    private Long hotelId; // 酒店ID
    @NotNull
    private String ratePlanId; // 价格计划Id

    // 0	无要求
    //2	尽量安排无烟房
    //8	尽量安排大床	仅当床型为“X张大床或X张双床”时，此选项才有效
    //10	尽量安排双床房	仅当床型为“X张大床或X张双床”时，此选项才有效
    //11	尽量安排吸烟房
    //12	尽量高楼层
    //15	尽量安排有窗房
    //16	尽量安排安静房间
    //18	尽量安排相近房间
    private String specialRemarks;
    @NotNull
    private Integer numberofRooms; // 预定的房间数
    private Integer manNum; // 成人数
    private Integer childNum; // 儿童数
    private List<Integer> childAges; // 儿童年龄
    @NotNull
    private String checkin; // 入住日期
    @NotNull
    private String checkout; // 离店日期
    private Integer totalPrice; // 下单总价
    private String contactName; // 分销商业务联系人姓名
    private String contactPhone; // 分销商业务联系人手机号码
    private String contactEmail; // 分销商业务联系人邮箱
    @NotNull
    private String customerArriveTime; // 客人到店时间

    @NotNull
    private String roomNameCn;
    @NotNull
    private String roomPic;
    @NotNull
    private String hotelIdPic;
    private List<String> customerInfo; // 入住人信息
}
