package com.zswl.cloud.springBatch.client.model.dfy.Hotel.request;

import com.zswl.cloud.springBatch.client.model.dfy.DfyBaseData;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@NoArgsConstructor
@AllArgsConstructor
public class HotelListRequest extends DfyBaseData {


    // 起始位置，配合limit可以实现分页，如0代表第一页，i*limit代表第（i+1）页 i=1,2....n 正整数
    private Integer start;

    // 一页露出多少条(最多30)
    private Integer limit;

    // 关键词
    private String keyword;

    // 城市code
    private Integer cityCode;

    // 城市名称
    private String cityName;

    // 入住日期，格式为：YYYY-MM-DD
    private String checkInDate;

    // 离店日期，格式为：YYYY-MM-DD
    private String checkOutDate;

    // 排序规则(默认recommend.推荐值排序) recommend:推荐值降序 satisfaction :口碑 price-asc:起价升序 price-desc:起价降序
    private String sortKey;

    // 是否返回聚合筛选条件,0:否,1:是。注意：returnFilter=1时搜索性能较差，尽量设置returnFilter=0
    private Integer returnFilter;

    // 聚合筛选条件
    private FilterInfo filter;


    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public static class FilterInfo {
        // 起始位置，配合limit可以实现分页，如0代表第一页，i*limit代表第（i+1）页 i=1,2....n 正整数
        private Integer start;

        // 一页露出多少条(最多30)
        private Integer limit;

        // 关键词
        private String keyword;

        // 城市code
        private Integer cityCode;

        // 城市名称
        private String cityName;

        // 入住日期，格式为：YYYY-MM-DD
        private String checkInDate;

        // 离店日期，格式为：YYYY-MM-DD
        private String checkOutDate;

        // 排序规则(默认recommend.推荐值排序) recommend:推荐值降序 satisfaction :口碑 price-asc:起价升序 price-desc:起价降序
        private String sortKey;

        // 是否返回聚合筛选条件,0:否,1:是。注意：returnFilter=1时搜索性能较差，尽量设置returnFilter=0
        private Integer returnFilter;

        // 聚合筛选条件
        private FilterInfo filter;

        // 星级
        private Integer[] star;

        // 区域关键字 通过搜索结果反向聚合
        private String poiKey;

        // 经纬度对应的编号 取经纬度同层参数code
        private Integer poiCode;

        // 品牌 通过搜索结果反向聚合
        private Integer[] brand;

        // 房价范围 自定义
        private String[] price;

        // 设施 通过搜索结果反向聚合
        private Integer[] facility;

        // 经度
        private Double longitude;

        // 纬度
        private Double latitude;

        // 特色 通过搜索结果反向聚合
        private Integer[] feature;


    }
}
