package com.zswl.cloud.springBatch.client.model.dfy.Hotel.response;

import com.zswl.cloud.springBatch.client.model.dfy.DfyResponseBase;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

@Data
@NoArgsConstructor
@AllArgsConstructor
public class HotelDetailResponse extends DfyResponseBase {

    private Datas data;


    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public class Datas {

        // 酒店ID
        private Long hotelId;

        // 酒店地址
        private String address;

        // 酒店中文名
        private String chineseName;

        // 酒店英文名
        private String englishName;

        // 装修时间
        private String decorateDate;

        // 星级
        private Integer star;

        // 星级名
        private String starName;

        // 酒店房间数
        private Integer roomCount;

        // 开业年份
        private String debutYear;

        // 酒店联系电话
        private String tel;

        // 纬度
        private Double latitude;

        // 经度
        private Double longitude;

        // google 经度
        private Double longitudeGoogle;

        // google 维度
        private Double latitudeGoogle;

        // 酒店介绍
        private String instruction;

        // 图片列表
        private List<Picture> pictures;

        // 服务
        private List<Service> services;

        // 设施项目
        private List<Facility> facilities;

        // 周边交通和位置
        private List<PoiInfo> poiInfos;

        // 政策
        private PolicyInfo policy;


    }

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public class Picture {

        // 图片存储路径。详见《图片尺寸说明》
        private String path;

        // 图片代表位置的描述（如头图，外观，大堂）
        private String name;
    }

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public class Service {
        // 服务code
        private String code;

        // 服务名
        private String name;

        // 服务类型名
        private String typeName;

        // 服务状态
        private String status; // 0=无, 1=有, 2=不确定, 3=部分有

        // 服务类型code
        private String typeCode;
    }

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public class Facility {

        // 设施code
        private String code;

        // 设施名
        private String name;

        // 设施类型名
        private String typeName;

        // 设施状态
        private String status; // 0=无, 1=有, 2=不确定, 3=部分有

        // 设施类型code
        private String typeCode;


    }

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public class PoiInfo {

        // POI类型code
        private Integer type;

        // POI类型名称
        private String name;

        // POI信息列表
        private List<SubPoiInfo> subPoiInfos;

    }

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public class PolicyInfo {

        // 退订规则
        private String cancel;

        // 特殊要求
        private String requirements;

        // 离店时间
        private String checkOutTime;

        // 儿童
        private String children;

        // 入住时间
        private String checkInTime;

        // 接受证件
        private String acceptCreditCards;

        // 入住离店时间
        private String arrivalDeparture;

        // 入住需要
        private String depositPrepaid;

        // 是否可携带宠物
        private String pet;
    }

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public class SubPoiInfo {

        // 距离酒店多少公里
        private String distance;

        // POI名称
        private String name;

        // POI描述
        private String trafficDesc;
    }

}
