package com.zswl.cloud.springBatch.client.model.dfy.Hotel.response;

import com.zswl.cloud.springBatch.client.model.dfy.DfyResponseBase;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;

@Data
@NoArgsConstructor
@AllArgsConstructor
public class OrderDetailResponse extends DfyResponseBase {

    private Datas data;


    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public class Datas {

        private ContactInfo contactInfo; // 是否下单成功
        private HotelInfo hotelInfo; // 订单Id
        private OrderInfo orderInfo; // 笛风订单号是否新生成，1：是，0：否

    }

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public class ContactInfo {

        @ApiModelProperty(value = "分销商联系人姓名")
        private String contactName;

        @ApiModelProperty(value = "分销商联系人电话")
        private String contactPhone;

        @ApiModelProperty(value = "分销商联系人邮箱")
        private String contactEmail;


    }

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public class HotelInfo {

        @ApiModelProperty(value = "酒店Id")
        private Long hotelId;

        @ApiModelProperty(value = "酒店名称")
        private String hotelName;

        @ApiModelProperty(value = "酒店地址")
        private String hotelAddress;

        @ApiModelProperty(value = "酒店电话")
        private String hotelTel;

        @ApiModelProperty(value = "物理房型类型")
        private String roomType;

        @ApiModelProperty(value = "物理房型名称")
        private String roomName;

        @ApiModelProperty(value = "床型")
        private String bedType;

        @ApiModelProperty(value = "早餐（文本描述）")
        private String breakfastDesc;

        @ApiModelProperty(value = "早餐（结构化）")
        private RatePlanInfoResponse.Meal meal;

        @ApiModelProperty(value = "取消政策（文本描述）")
        private String cancelRule;

        @ApiModelProperty(value = "取消政策（结构化）")
        private RatePlanInfoResponse.Refund refund;

        @ApiModelProperty(value = "发票开具方式", allowableValues = "0, 1")
        private Integer invoiceType;

        @ApiModelProperty(value = "最大可入住人数")
        private Integer maxOccupancy;

        @ApiModelProperty(value = "有线宽带", allowableValues = "FREE, NONE, PART_CHARGE, PART_SUPPORT_AND_CHARGE, CHARGE, UNKNOWN, PART_SUPPORT_AND_FREE, PART_SUPPORT_AND_PART_CHARGE")
        private String broadband;

        @ApiModelProperty(value = "无线wifi", allowableValues = "FREE, NONE, PART_CHARGE, PART_SUPPORT_AND_CHARGE, CHARGE, UNKNOWN, PART_SUPPORT_AND_FREE, PART_SUPPORT_AND_PART_CHARGE")
        private String wifi;


    }


    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public class OrderInfo {

        @ApiModelProperty(value = "总价")
        private BigDecimal totalPrice;

        @ApiModelProperty(value = "入店日期")
        private String checkin;

        @ApiModelProperty(value = "离店日期")
        private String checkout;

        @ApiModelProperty(value = "预订房间数")
        private Integer numberofRooms;

        @ApiModelProperty(value = "订单状态", allowableValues = "待付款, 酒店确认中, 确认失败, 已确认, 已取消, 已完成")
        private String orderStatus;

        @ApiModelProperty(value = "下单时间")
        private String orderTime;

        @ApiModelProperty(value = "已支付金额")
        private Integer payedPrice;

        @ApiModelProperty(value = "确认号")
        private String confirmationNumber;


    }


}
