package com.zswl.cloud.springBatch.client.model.dfy.Hotel.response;

import com.zswl.cloud.springBatch.client.model.dfy.DfyResponseBase;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

@Data
@NoArgsConstructor
@AllArgsConstructor
public class QueryNewResponse extends DfyResponseBase {

    private Datas data;


    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public class Datas {

        // 目的地列表
        private List<Dest> destinationSuggests;

    }

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public class Dest {
        // 编号，如果poiType是7，该编号就是酒店ID（hotelId）
        private Integer code;

        // poi类型值：1-城市，2-行政区，3-商圈，4-景点，7-酒店，12-机场，13-地铁，14-火车站
        private Integer poiType;

        // 显示名称
        private String displayName;

        // 纬度坐标值
        private String latitude;

        // 经度坐标值
        private String longitude;

        // 城市code
        private Integer cityCode;

        // 城市名
        private String cityName;

        // 酒店英文名
        private String englishName;

        // 酒店中文名
        private String chineseName;

        // 酒店数量
        private Integer hotelCount;

    }


}
