package com.zswl.cloud.springBatch.client.model.dfy.Hotel.response;

import com.zswl.cloud.springBatch.client.model.dfy.DfyResponseBase;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;
import java.util.List;

@Data
@NoArgsConstructor
@AllArgsConstructor
public class RatePlanResponse extends DfyResponseBase {

    private Datas data;


    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public class Datas {

        private String id; // 价格计划ID
        private String name; // 价格计划名称
        private String bedType; // 床型简称
        private String bedInfo; // 床型描述
        private String mealInfo; // 早餐（文本描述）
        private RatePlanInfoResponse.Meal meal; // 早餐（结构化）
        private String networkInfo; // 网络描述
        private String wifi; // wifi服务
        private Integer guestType; // 宾客类型：1 (所有宾客)、2 (内宾)、3 (中宾)、4 (外宾)
        private Integer invoiceType; // 发票开具方式
        private Integer maxOccupancy; // 每间房最多可住人数
        private RatePlanInfoResponse.CancelInfo cancel; // 取消政策（文本描述）
        private RatePlanInfoResponse.Refund refund; // 取消政策（结构化）
        private List<RatePlanInfoResponse.PromotionRule> promotionRules; // 促销信息
        private String guidedPrice; // 每日价格
        private BigDecimal averagePrice; // 平均结算价
        private BigDecimal totalPrice; // 下单总价
        private BigDecimal ratePrice; // 平均房费价
        private BigDecimal taxAndFeePrice; // 平均税费价
        private List<Remark> remarks; // 预定页温馨提示

    }

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public class Remark {

        private String value;

        private Integer seq;

    }


}
