package com.zswl.cloud.springBatch.client.model.dfy.Ticket.response;

import com.zswl.cloud.springBatch.client.model.dfy.DfyResponseBase;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;
import java.util.List;

@Data
@NoArgsConstructor
@AllArgsConstructor
public class DetailResponse extends DfyResponseBase {

    private Datas data;


    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public class Datas {

        // 门票产品ID
        private int productId;

        // 资源ID
        private String resourceId;

        // 产品名称
        private String productName;

        // 景点id
        private Integer scenicId;

        // 单位元,景点价（当前景点的价格，信息可能有滞后，仅供参考）
        private BigDecimal webPrice;

        // 单位元,分销起价（所有团期中最低的价格，仅供参考）
        private BigDecimal salePrice;

        // 取票方式：1实体票 8预付电子票
        private Integer drawType;

        // 取票地点
        private String drawAddress;

        // 门票类型：1门票 2联票 3套票 4专项
        private Integer subType;

        // 有效期
        private String indate;

        // 预订截止天数
        private Integer advanceDay;

        // 预订截止小时数
        private Integer advanceHour;

        // 预订须知
        private String bookNotice;

        // 起订张数
        private Integer limitNumLow;

        // 最多预订张数
        private Integer limitNumHigh;

        // 预订项要求
        private Integer custInfoLimit;

        // 证件类型，逗号分隔
        private String certificateType;

        // 入园凭证
        private Integer enterCertificate;

        private AdmissionVoucher admissionVoucher;

        // 其他说明
        private String info;

        // 退改规则
        private String mpLossInfo;

        // 产品归属
        private Integer systemFlag;

        // 门票分类
        private Integer mpType;

        private List<PriceCalendar> priceCalendar;


    }

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public class AdmissionVoucher {
        // 入园方式编码
        private String admissionVoucherCode;

        // 入园方式描述
        private String admissionVoucherDesc;

        // 短信内容
        private String smsMessage;

    }

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public class PriceCalendar {


        // 单位元,分销价（下单用这个价格）
        private BigDecimal salePrice;

        // 团期
        private String departDate;


    }


}
