package com.zswl.cloud.springBatch.client.model.dfy.Ticket.response;

import com.zswl.cloud.springBatch.client.model.dfy.DfyResponseBase;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;
import java.util.List;

@Data
@NoArgsConstructor
@AllArgsConstructor
public class OrderDetailResponse extends DfyResponseBase {

    private Datas data;


    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public class Datas {

        // 订单状态
        private String orderStatus;

        private OrderInfo orderInfo;


    }

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public class OrderInfo {

        // 订单id
        private int orderId;

        // 支付开关 0.不可支付，1.可以支付；分销商系统需要控制，当canPay="1"时，才调用【出票(代扣)接口】。
        private String canPay;

        // 产品ID
        private Integer productId;

        // 景点ID
        private Integer scenicId;

        // 景点名称
        private String scenicName;


        // 下单时间
        private String orderTime;

        // 出游日期
        private String planDate;

        // 预订数量
        private Integer bookNumber;

        // 总价
        private BigDecimal amoutPrice;

        // 取票地址
        private String pickUpAddress;

        // 凭证码（“已完成”状态有值）
        private String externalOrderId;

        // 取票人信息
        private Contact contact;

        // 出游人信息
        private List<Tourist> touristList;

        // 入园方式及凭证信息
        private EnterCertificate enterCertificate;


        // 门票配送信息
        private Delivery delivery;
    }


    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public class Contact {

        // 取票人姓名
        private String contactName;

        // 取票人邮箱
        private String contactEmail;

        // 取票人手机号码
        private String contactTel;

        // 证件类型：1、二代身份证2、护照3、军官证4、港澳通行证7、台胞证8、回乡证9、户口簿10、出生证明11、台湾通行证
        private Integer psptType;

        // 证件号码
        private String psptId;
    }


    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public class Tourist {

        // 游客姓名
        private String name;

        // 证件类型：1、二代身份证2、护照3、军官证4、港澳通行证7、台胞证8、回乡证9、户口簿10、出生证明11、台湾通行证
        private Integer psptType;

        // 证件号码
        private String psptId;

        // 电话号码
        private String tel;

        // 邮箱
        private String email;
    }

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public class EnterCertificate {

        // 入园方式
        private String enterCertificateType;

        // 入园凭证附件
        private EnterCertificateTypeInfo enterCertificateTypeInfo;

        // 入园凭证文本说明
        private String enterCertificateTxt;

    }


    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public class EnterCertificateTypeInfo {

        // 资源ID
        private Integer resourceId;

        private Integer requirementId;

        // 凭证对象 可能有多个
        private List<TicketCertInfo> ticketCertInfos;


    }

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public class TicketCertInfo {

        // 凭证类型   1.纯文本  2.二维码 3.PDF
        private Integer certType;


        // 凭证文本或者URL
        private List<String> fileUrls;


    }

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public class Delivery {

        // 配送类型：1配送 2自取
        private Integer deliveryType;

        // 收件人
        private String receiverName;

        // 收件电话
        private String telNum;

        // 收件地址
        private String deliveryEndAddress;

        // 邮编
        private String zipCode;


    }


}
