package com.zswl.cloud.springBatch.client.model.dfy.Ticket.response;

import com.zswl.cloud.springBatch.client.model.dfy.DfyResponseBase;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

@Data
@NoArgsConstructor
@AllArgsConstructor
public class ScenicDetailResponse extends DfyResponseBase {

    private Datas data;

    @Data
    public static class Datas {


        // 景点ID
        private int scenicId;

        // 景点名称
        private String scenicName;

        // 预订须知，该字段为Unicode编码
        private String bookNotice;

        // 景点所在城市
        private String cityName;

        // 景点所在省份（国外景点可能是国家）
        private String provinceName;

        // 谷歌经纬度
        private String glocation;

        // 百度经纬度
        private String blocation;

        // 景点营业时间
        private String openTime;

        // 景点地址
        private String scenicAddress;

        // 景点图片
        private String defaultPic; // URL需要处理，详见《图片尺寸设置说明》

        // 景点描述
        private String scenicDescription;

        // 推荐
        private String recommend;

        // 交通信息
        private String trafficBus;

        // 备注信息
        private String remark;

        private List<Ticket> ticketList;
        private List<Ticket> disTickets;

    }

    @Data
    public static class Ticket {

        // 门票产品ID
        private String productName;
        // 产品名称
        private int productId;

        // 单位元,景点价 非下单价格
        private double webPrice;

        // 单位元,销售价,当价格为0时，需要单独查询门票详情，其中有价格日历内容，获取正确的价格，在下单时也是要使用详情中的价格。非下单价格
        private double salePrice;


    }
}
