package com.zswl.cloud.springBatch.client.model.dfy.pub.response;

import com.zswl.cloud.springBatch.client.model.dfy.DfyResponseBase;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

@Data
@NoArgsConstructor
@AllArgsConstructor
public class QueryResponse extends DfyResponseBase {

    private Datas data;


    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public class Datas {

        private Integer count;

        private Integer pages;

        private List<QueryBillsDto> rows;

    }

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public class QueryBillsDto {

        // 本次交易金额
        private String amount;

        // 订单号
        private String bizOrderId;

        // 账户流水号；与途牛钱包网站【交易管理】模块呈现的流水号一致。
        private String merFlowNo;

        // 代扣流水号；与【出票(代扣)接口】返回的outTradeNo 字段对应，可用于系统自动对账
        private String outTradeNo;

        // 账单处理结果，1处理完成-1处理失败3处理
        private Integer status;

        // 账单类型：1支付，2代扣，3代付，4退款，5提现
        private Integer billType;

        // 账单类型描述
        private String billTypeDesc;

        // 添加时间，格式如：2016-03-11 13:54:52
        private String time;

        // 产品品类
        private String productType;

        // 备注
        private String remark;

    }


}
