package com.zswl.cloud.springBatch.client.model.ypp.kfc.request;

import com.zhongshu.payment.client.type.Channel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * TicketOrderChannelCreateDto，渠道下单
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
public class CreateOrdereRquest {

    private Channel channel;

    private String shopName;

    private String goodsName;

    private String imageCnUrl;
    /**
     * appid
     */
    private String appId;
    /**
     * 城市id
     */
    private Long cityId;
    private long eatType;
    /**
     * 自定义参数
     */
    private String entPara;
    /**
     * 取餐时间:0 0分钟，1 10分钟 2 20分钟 3 30分钟
     */
    private Long mealTime;
    /**
     * 手机号
     */
    private String phone;
    /**
     * 购买的餐品列表
     */
    private List<Product> products;
    /**
     * 外卖订单必传
     */
    private RecAddrDto recAddr;
    /**
     * 备注
     */
    private String remark;
    /**
     * 店铺id
     */
    private String shopId;
    /**
     * 是否需要餐具
     */
    private Boolean tableWare;

    @Data
    @AllArgsConstructor
    @NoArgsConstructor
    public class Product {
        private Boolean hasRefund;
        /**
         * 产品图片
         */
        private String imageUrl;
        private Long index;
        private String linkId;
        /**
         * 产品名称
         */
        private String nameCn;
        /**
         * 平台订单号
         */
        private String orderId;
        /**
         * 有票订单号
         */
        private String orderSn;
        private Double orgPrice;
        /**
         * 产品id（多规格里面的上级产品id，非多规格留空）
         */
        private String pId;
        /**
         * 产品id
         */
        private String productId;
        /**
         * 数量
         */
        private long quantity;
        /**
         * 退款金额
         */
        private Double refundAmount;
        /**
         * 退款数量
         */
        private Double refundCount;
        private List<Selected> selected;
        private Double selPrice;
        private String spec;
    }

    @Data
    @AllArgsConstructor
    @NoArgsConstructor
    public class Selected {
        private List<KfcOrderProductItem> products;
        /**
         * 固定值0
         */
        private Long round;
    }

    @Data
    @AllArgsConstructor
    @NoArgsConstructor
    public class KfcOrderProductItem {
        private String linkId;
        private String productId;
        private Long quantity;
    }

    @Data
    @AllArgsConstructor
    @NoArgsConstructor
    public class RecAddrDto {
        /**
         * 地址
         */
        private String addr;
        /**
         * 联系人
         */
        private String contact;
        private String createTime;
        /**
         * 性别
         */
        private String gender;
        private String id;
        /**
         * 维度
         */
        private double lat;
        /**
         * 经度
         */
        private double lon;
        /**
         * 门牌号
         */
        private String number;
        /**
         * 联系电话
         */
        private String phone;
        private String userId;
    }

}