package com.zswl.cloud.springBatch.client.model.ypp.kfc.request;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.time.OffsetDateTime;
import java.util.List;

/**
 * MovieOrderQuery
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
public class OrderListRequest {
    /**
     * appid
     */
    private String appId;
    /**
     * 截至时间
     */
    private OffsetDateTime endTime;
    private Boolean exportExcel;
    /**
     * 订单号
     */
    private String orderCustomId;
    /**
     * 订单状态
     * 0等待支付
     * 1订单已付
     * 2等待出码
     * 3订单成功
     * 4订单失败
     * 5订单取消
     * 6订单退款
     * 7未付取消
     * 8部分退款
     * 9订单锁定
     * 10客服处理中
     * 11等待配送
     * 12配送中
     */
    private Long orderState;
    private Long orderType;
    private long pageIndex;
    private long pageSize;
    /**
     * 查询类型：1 创建时间，2 支付时间,(需要同时传时间段)
     */
    private Long queryType;
    /**
     * 起始时间
     */
    private OffsetDateTime startTime;
    /**
     * 标题
     */
    private String title;
    /**
     * 用户id
     */
    private String userId;
    /**
     * 用户手机
     */
    private String userMobile;
    /**
     * 用户姓名
     */
    private String userName;


}