// ApifoxModel.java

package com.zswl.cloud.springBatch.client.model.ypp.kfc.response;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * TicketOrderSimpleDtoRequestResult
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
public class OrderDetailResponse {
    /**
     * code
     */
    private Long code;
    private KfcOrderChannelDto data;
    /**
     * message
     */
    private String message;

    @Data
    @AllArgsConstructor
    @NoArgsConstructor
    public class KfcOrderChannelDto {
        /**
         * 门店地址
         */
        private String address;
        /**
         * 所属APPId
         */
        private String appId;
        /**
         * 用户头像
         */
        private String avatarUrl;
        /**
         * 竞价次数
         */
        private Long biddingCount;
        /**
         * 竞价截止时间
         */
        private String biddingEndTime;
        /**
         * 城市id
         */
        private Long cityId;
        /**
         * 城市名称
         */
        private String cityName;
        /**
         * 取餐码，多个用空格分开，如(A3301 A3302)
         */
        private String codes;
        /**
         * 购买数量
         */
        private Long count;
        /**
         * 创建时间
         */
        private String createTime;
        private Long eatType;
        private String eatTypeName;
        private String entPara;
        private String entUserId;
        /**
         * 本订单佣金
         */
        private Double epCommission;
        /**
         * 上级代理佣金（无上级代理为0）
         */
        private Double epParentCommission;
        /**
         * 归属企业用户父id
         */
        private String epParentId;
        /**
         * 归属企业用户id
         */
        private String epUserId;
        private String epUserName;
        private String id;
        /**
         * 图片地址
         */
        private String imageUrl;
        /**
         * 订单说明
         */
        private String info;
        /**
         * 是否渠道收款
         */
        private Boolean isChannelPay;
        /**
         * Lat
         */
        private Double lat;
        /**
         * Lon
         */
        private Double lon;
        /**
         * 出餐时间（单位：秒）
         */
        private Long makeMealSeconds;
        /**
         * 取餐时间:0 0分钟，1 10分钟 2 20分钟 3 30分钟
         */
        private Long mealTime;
        /**
         * 订单模式 0自动 1人工
         */
        private Long mode;
        private Double offsetPrice;
        /**
         * 自定义订单号
         */
        private String orderCustomId;
        /**
         * 订单名称
         */
        private String orderName;
        /**
         * 外部平台支付凭证号
         */
        private String orderPayId;
        /**
         * 订单签名
         */
        private String orderSign;
        /**
         * 0:ReadyToPay,等待支付;
         *
         * 1:Paid,订单已付;
         *
         * 2:WaitCode,等待出码;
         *
         * 3:Success,订单成功;
         *
         * 4:Failed,订单失败;
         *
         * 5:Canceled,订单取消;
         *
         * 6:Refunded,订单退款;
         *
         * 7:NopayCancel,未付取消;
         *
         * 8:PartRefunded,部分退款;
         *
         * 9:Locked,订单锁定;
         *
         * 10:WaitCustomer,客服处理中;
         *
         * 11:WaitDelivery,等待配送;
         *
         * 12:Deliverying,配送中;
         *
         * 13:WaitKfc,正在出餐;
         */
        private Long orderState;
        /**
         * 订单状态
         */
        private String orderStateName;
        private Long orderType;
        /**
         * 订单类型
         */
        private String orderTypeName;
        /**
         * 订单原价（市场价）
         */
        private Double originPrice;
        /**
         * 支付时间
         */
        private String paidTime;
        /**
         * 支付APPId
         */
        private String payAppId;
        /**
         * 外部平台支付流水号
         */
        private String payTranId;
        /**
         * 支付方式
         */
        private Long payType;
        private String payUrl;
        /**
         * 平台城市id
         */
        private String platformCityId;
        /**
         * 平台订单ID
         */
        private String platformOrderId;
        /**
         * 产品信息（json字符串，内容与创建订单提交products参数一致）
         */
        private String productsInfo;
        private String pushUrl;
        /**
         * 取餐二维码的值，多个用空格分开
         */
        private String qrCodes;
        /**
         * 等待单数
         */
        private Long queueSize;
        /**
         * 外卖配送地址
         */
        private String recAddress;
        /**
         * 退款金额
         */
        private Double refundAmount;
        /**
         * 退款产品
         */
        private List<KfcOrderProduct> refundProducts;
        /**
         * 退款时间
         */
        private String refundTime;
        /**
         * 备注
         */
        private String remark;
        /**
         * 店铺code
         */
        private String shopCode;
        /**
         * 店铺ID
         */
        private String shopId;
        /**
         * 店铺
         */
        private String shopName;
        /**
         * 订单成功时间
         */
        private String successTime;
        /**
         * 头像地址
         */
        private String supplierAvatarUrl;
        /**
         * 供应商Id
         */
        private String supplierId;
        /**
         * 昵称
         */
        private String supplierName;
        /**
         * 供应商备注
         */
        private String supplierRemark;
        /**
         * 是否需要餐具
         */
        private Boolean tableWare;
        /**
         * 分销商总价（非分销模式为0）
         */
        private Double totalDistributionPrice;
        /**
         * 订单总金额（以建议销售价计算）
         */
        private Double totalUserPrice;
        /**
         * 更新时间
         */
        private String updateTime;
        /**
         * 用户ID
         */
        private String userId;
        /**
         * 用户手机
         */
        private String userMobile;
        /**
         * 用户姓名
         */
        private String userName;
        /**
         * 等待时间(分钟)
         */
        private Long waitTime;
    }

// KfcOrderProduct.java


    /**
     * KfcOrderProduct
     */
    @Data
    public class KfcOrderProduct {
        private Boolean hasRefund;
        private String imageUrl;
        private Long index;
        private String linkId;
        private String nameCn;
        /**
         * 平台订单号
         */
        private String orderId;
        /**
         * 有票订单号
         */
        private String orderSn;
        private Double orgPrice;
        /**
         * 产品id（多规格里面的上级产品id，非多规格留空）
         */
        private String pId;
        /**
         * 产品id
         */
        private String productId;
        private long quantity;
        /**
         * 退款金额
         */
        private Double refundAmount;
        /**
         * 退款数量
         */
        private Double refundCount;
        private List<KfcOrderProductRound> selected;
        private Double selPrice;
        private Double settlePrice;
        private String spec;
    }


    /**
     * KfcOrderProductRound
     */
    @Data
    public class KfcOrderProductRound {
        private List<KfcOrderProductItem> products;
        private Long round;
    }

// KfcOrderProductItem.java


    /**
     * KfcOrderProductItem
     */
    @Data
    public class KfcOrderProductItem {
        private String linkId;
        private String productId;
        private Long quantity;
    }

}
