package com.zswl.cloud.springBatch.client.model.ypp.movie.request;

import com.zhongshu.payment.client.type.Channel;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.time.OffsetDateTime;

/**
 * TicketOrderChannelCreate2Dto，渠道下单
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
public class CreateOrder2Request {

    private Channel channel;
    /**
     * 有票票分配的appId
     */
    private String appId;
    /**
     * 影院地址
     */
    private String cinemaAddress;
    /**
     * 影院编码
     */
    private String cinemaCode;
    /**
     * 影院名称
     */
    private String cinemaName;
    /**
     * 城市名称
     */
    private String cityName;
    /**
     * 快速票
     */
    private Boolean fastTicket;
    /**
     * 影厅名称
     */
    private String hallName;
    /**
     * 是否情侣座(true/false)
     */
    private Boolean loveSeat;
    /**
     * 影片编码
     */
    private String movieCode;
    /**
     * 影片名称
     */
    private String movieName;
    /**
     * 影票类型（2D/ 3D）
     */
    private String movieVersion;
    /**
     * 第三方订单号
     */
    private String orderId;

    private Integer orderPayMode;
    /**
     * 原票价单价
     */
    private Double originPrice;
    /**
     * 影片海报图
     */
    private String postImageUrl;
    /**
     * 座位名称（多个用逗号分隔）
     */
    private String seatNames;
    /**
     * 开场时间
     */
    private String sessionBeginTime;
    /**
     * 结束时间
     */
    private String sessionEndTime;
    /**
     * 是否可调座
     */
    private boolean switchSeat;
    /**
     * 是否是测试订单（测试订单不会真实出票，请联系测试人员模拟出票、退款等）
     */
    private Boolean test;
    /**
     * 用户手机号
     */
    private String userMobile;


}