package com.zswl.cloud.springBatch.client.model.ypp.movie.request;

import com.zhongshu.payment.client.type.Channel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.time.OffsetDateTime;

/**
 * TicketOrderChannelCreateDto，渠道下单
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
public class CreateOrdereRquest {
    /**
     * 应用AppId
     */
    @ApiModelProperty(hidden = true)
    private String appId;
    /**
     * 观众列表ID，用,分隔
     */
    private String audience;
    /**
     * 购买模式：0优惠购票 1原价票
     */
    private Long buyModel;
    /**
     * 影院地址
     */
    private String cinemaAddress;
    /**
     * 影院编码
     */
    private String cinemaCode;
    /**
     * 影院ID
     */
    private String cinemaId;
    /**
     * 影院经度
     */
    private Double cinemaLat;
    /**
     * 影院纬度
     */
    private Double cinemaLng;
    /**
     * 影院名称
     */
    private String cinemaName;
    /**
     * 城市ID
     */
    private String cityId;
    /**
     * 城市名称
     */
    private String cityName;
    /**
     * 自定义参数
     */
    private String entPara;
    /**
     * 影厅名称
     */
    private String hallName;
    /**
     * 电影编码
     */
    private String movieCode;
    /**
     * 电影ID
     */
    private String movieId;
    /**
     * 电影名称
     */
    private String movieName;
    /**
     * 影票类型（英语 3D）
     */
    private String movieVersion;
    /**
     * 座位id，多个座位用逗号分隔
     */
    private String originalSeatIds;
    /**
     * 电影海报地址
     */
    private String postImageUrl;
    /**
     * 座位名称（多个用逗号分隔）
     */
    private String seatNames;
    /**
     * 开场时间
     */
    private String sessionBeginTime;
    /**
     * 结束时间
     */
    private String sessionEndTime;
    /**
     * 场次ID
     */
    private String sessionId;
    /**
     * 票源id
     */
    private String sourceId;
    /**
     * 用户手机号
     */
    private String userMobile;

    private Channel channel;

}