package com.zswl.cloud.springBatch.client.service;

import com.github.microservice.auth.client.content.ResultContent;
import com.zhongshu.payment.client.model.order.v2.CreatOrderResultModel;
import com.zswl.cloud.springBatch.client.model.dfy.Hotel.request.*;
import com.zswl.cloud.springBatch.client.model.dfy.Hotel.response.*;
import io.swagger.annotations.ApiOperation;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

@FeignClient(name = "springbatchservice/manager/dfy/hotel")
public interface DfyHotelService {

    @ApiOperation(" 目的地搜索")
    @RequestMapping(value = "queryNew", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    ResultContent<QueryNewResponse> queryNew(@RequestBody QueryNewRequest queryNewRequest);

    @ApiOperation(" 酒店搜索接口")
    @RequestMapping(value = "hotelList", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    ResultContent<HotelListResponse> hotelList(@RequestBody HotelListRequest hotelListRequest);

    @ApiOperation(" 酒店详情接口")
    @RequestMapping(value = "hotelDetail", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    ResultContent<HotelDetailResponse> hotelDetail(@RequestBody HotelDetailRequest hotelDetailRequest);

    @ApiOperation(" 房型及报价查询接口")
    @RequestMapping(value = "ratePlanInfo", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    ResultContent<RatePlanInfoResponse> ratePlanInfo(@RequestBody RatePlanInfoRequest ratePlanInfoRequest);

    @ApiOperation(" 实时询价接口")
    @RequestMapping(value = "ratePlan", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    ResultContent<RatePlanResponse> ratePlan(@RequestBody RatePlanRequest ratePlanRequest);

    @ApiOperation(" 创建订单接口")
    @RequestMapping(value = "addOrder", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    ResultContent<CreatOrderResultModel> addOrder(@RequestBody AddOrderRequest addOrderRequest);

    @ApiOperation(" 订单详情接口")
    @RequestMapping(value = "orderDetail", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    ResultContent<OrderDetailResponse> orderDetail(@RequestBody OrderDetailRequest orderDetailRequest);

    @ApiOperation(" 付款(代扣)接口")
    @RequestMapping(value = "submitOrder", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    ResultContent<SubmitOrderResponse> submitOrder(@RequestBody SubmitOrderRequest submitOrderRequest);

    @ApiOperation(" 取消订单接口")
    @RequestMapping(value = "cancelOrder", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    ResultContent<CancelOrderResponse> cancelOrder(CancelOrderRequest cancelOrderRequest);
}
