package com.zswl.cloud.springBatch.client.service;

import com.github.microservice.auth.client.content.ResultContent;
import com.zhongshu.payment.client.model.order.v2.CreatOrderResultModel;
import com.zswl.cloud.springBatch.client.model.dfy.Ticket.request.*;
import com.zswl.cloud.springBatch.client.model.dfy.Ticket.response.*;
import io.swagger.annotations.ApiOperation;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

@FeignClient(name = "springbatchservice/manager/dfy/ticket")
public interface DfyTicketService {


    @ApiOperation(" 景点列表查询")
    @RequestMapping(value = "scenicList", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    ResultContent<ScenicListResponse> scenicList(@RequestBody ScenicListRequest scenicListRequest);

    @ApiOperation(" 景点详情接口")
    @RequestMapping(value = "scenicDetail", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    ResultContent<ScenicDetailResponse> scenicDetail(@RequestBody ScenicDetailRequest scenicDetailRequest);

    @ApiOperation(" 特权门票查询接口")
    @RequestMapping(value = "privilegeTicketList", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    ResultContent<PrivilegeTicketListResponse> privilegeTicketList(@RequestBody PrivilegeTicketListRequest privilegeTicketListRequest);

    @ApiOperation(" 门票详情接口")
    @RequestMapping(value = "detail", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    ResultContent<DetailResponse> detail(@RequestBody DetailRequest detailRequest);

    @ApiOperation(" 创建订单接口")
    @RequestMapping(value = "createOrderNew", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    ResultContent<CreatOrderResultModel> createOrderNew(@RequestBody CreateOrderNewRequest createOrderNewRequest);

    @ApiOperation(" 取消订单")
    @RequestMapping(value = "cancelOrder", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    ResultContent cancelOrder(@RequestBody CancelOrderRequest cancelOrderRequest);

    @ApiOperation(" 出票(代扣)接口")
    @RequestMapping(value = "submitOrderResponse", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    ResultContent<SubmitOrderResponse> submitOrderResponse(@RequestBody SubmitOrderRequest submitOrderRequest);

    @ApiOperation(" 订单详情接口")
    @RequestMapping(value = "orderDetail", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    ResultContent<OrderDetailResponse> orderDetail(@RequestBody OrderDetailRequest orderDetailRequest);

    @ApiOperation(" 订单状态接口")
    @RequestMapping(value = "orderStatus", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    ResultContent<OrderStatusResponse> orderStatus(@RequestBody OrderStatusRequest orderStatusRequest);

    @ApiOperation(" 核销查询接口")
    @RequestMapping(value = "verifyOrder", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    ResultContent<VerifyOrderResponse> verifyOrder(@RequestBody VerifyOrderRequest verifyOrderRequest);

    @ApiOperation(" 退票申请接口")
    @RequestMapping(value = "tuiPiao", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    ResultContent<TuiPiaoResponse> tuiPiao(@RequestBody TuiPiaoRequest tuiPiaoRequest);

    @ApiOperation(" 同步景区信息")
    @RequestMapping(value = "sync", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    void sync();


}
