package com.zswl.cloud.springBatch.client.service;

import cn.hutool.json.JSONObject;
import com.github.microservice.auth.client.content.ResultContent;
import com.zhongshu.payment.client.model.order.v2.CreatOrderResultModel;
import com.zswl.cloud.springBatch.client.model.qiuxiang.OrderDelitResponse;
import com.zswl.cloud.springBatch.client.model.qiuxiang.OrderRequest;
import io.swagger.annotations.ApiOperation;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

@FeignClient(name = "springbatchservice/manager/qiuxiang")
public interface QiuXiangService {


    @ApiOperation("创建订单")
    @RequestMapping(value = "placeOrder", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    ResultContent<CreatOrderResultModel> placeOrder(@RequestBody OrderRequest orderRequest);

    @ApiOperation("订单详情")
    @RequestMapping(value = "orderDelit", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    ResultContent<OrderDelitResponse> orderDelit(String orderId);
    @ApiOperation("取消订单")
    @RequestMapping(value = "cancelOrder", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    ResultContent<OrderDelitResponse>  cancelOrder(String orderId, String reason) ;

    @ApiOperation("订单详情")
    @RequestMapping(value = "driverLocation", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    ResultContent<OrderDelitResponse> driverLocation(String orderId);

    @RequestMapping(value = "driverLocationLog", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    ResultContent<OrderDelitResponse> driverLocationLog(String orderId);
}
