package com.zswl.cloud.springBatch.client.service;

import com.github.microservice.auth.client.content.ResultContent;
import com.zswl.cloud.springBatch.client.model.request.XiaoJuQueryUserPromotionListModel;
import com.zswl.cloud.springBatch.client.model.xiaoju.QueryApiStorePriceRequest;
import com.zswl.cloud.springBatch.client.model.xiaoju.QueryGetPromotionRequest;
import com.zswl.cloud.springBatch.client.model.xiaoju.QueryUserPromotionListResponse;
import io.swagger.annotations.ApiOperation;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import com.zswl.cloud.springBatch.client.model.xiaoju.GenPromotionInfo;

import java.util.List;
import java.util.Map;

@FeignClient(name = "springbatchservice/manager/xiaoju")
public interface XiaoJuService {


    @ApiOperation("加油站详情")
    @RequestMapping(value = "storeInfo", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    ResultContent<Map<String, String>> storeInfo(@RequestBody QueryApiStorePriceRequest queryApiStorePriceRequest);


    @ApiOperation("用户所有加油券")
    @RequestMapping(value = "queryUserPromotionList", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    ResultContent<QueryUserPromotionListResponse> queryUserPromotionList(@RequestBody XiaoJuQueryUserPromotionListModel xiaoJuQueryUserPromotionListModel);

    @ApiOperation("发放优惠券")
    @RequestMapping(value = "getPromotion", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    ResultContent getPromotion(@RequestBody QueryGetPromotionRequest queryGetPromotionRequest);


}
