package com.zswl.cloud.springBtach.server.core.api.ypp;

import cn.hutool.core.util.ObjectUtil;
import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpResponse;
import cn.hutool.http.HttpUtil;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.zswl.cloud.springBtach.server.core.dao.ApiLogDao;
import com.zswl.cloud.springBtach.server.core.domain.ApiLog;
import com.zswl.cloud.springBtach.server.core.helper.RedisHelper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;
import org.springframework.util.Assert;

import java.util.HashMap;

@Component
public class TokenApi {


    @Value("${ypp.entId}")
    private String entId;

    @Value("${ypp.appSecret}")
    private String appSecret;

    @Value("${ypp.appId}")
    private String appId;

    @Value("${ypp.test}")
    private Boolean test;

    @Autowired
    RedisHelper redisHelper;


    @Autowired
    private ApiLogDao apiLogDao;


    private final String tokenName = "ypp-token";
    private final String member_token = "member-token-";
    private final String tokenValue = "Bearer ";

    public String getoken() {
        Object value = redisHelper.getValue(tokenName);
        if (!ObjectUtil.isEmpty(value)) {
            return String.valueOf(value);
        }
        HashMap<String, String> para = new HashMap<>();
        para.put("entId", entId);
        para.put("appSecret", appSecret);
        JSONObject http = httpPost("https://channel.youpiaopiao.cn/api/oauth/token", para);
        String access_token = (String) http.getByPath("data.access_token");
        String token = tokenValue + access_token;
        redisHelper.cacheValue(tokenName, token, 82800);
        return token;
    }

    public String member_token(String userId, String mobile) {

        Object value = redisHelper.getValue(member_token + userId);
        if (!ObjectUtil.isEmpty(value)) {
            return String.valueOf(value);
        }

        HashMap<String, String> para = new HashMap<>();
        para.put("appId", appId);
        para.put("userId", userId);
        para.put("mobile", mobile);


        JSONObject entries = httpPost("https://channel.youpiaopiao.cn/api/oauth/member_token", para);
        String member_token = (String) entries.getByPath("data.access_token");
        redisHelper.cacheValue(member_token + userId, tokenValue + member_token, 86400);
        return member_token;
    }


    public String httpGet(String url) {
        ApiLog apiLog = new ApiLog();
        apiLog.setRequest(url);
        apiLog.setSystem("kfc/movie");
        String token = getoken();
        HttpRequest get = HttpUtil.createGet(url);
        HttpResponse execute = get.header("Authorization", token).execute();
        String body = execute.body();
        apiLog.setResponse(body);
        apiLogDao.save(apiLog);
        JSONObject entries = JSONUtil.parseObj(body);
        Integer code = (Integer) entries.get("code");
        Assert.isTrue(execute.isOk(), "飘飘响应错误");
        Assert.isTrue(code.equals(0), String.valueOf(entries.get("message")));
        return body;

    }


    public JSONObject httpPost(String url, Object body) {

        HttpRequest post = HttpUtil.createPost(url);
        if (!url.contains("api/oauth/token")) {
            String token = getoken();
            post.header("Authorization", token);
        }

        ApiLog apiLog = new ApiLog();
        apiLog.setRequest(url);
        apiLog.setSystem("kfc/movie");
        apiLog.setService(url);
        HttpResponse execute = post.body(JSONUtil.toJsonStr(body)).execute();
        String response = execute.body();
        apiLog.setRequest(JSONUtil.toJsonStr(body));
        apiLog.setResponse(response);
        apiLogDao.save(apiLog);
        JSONObject entries = JSONUtil.parseObj(response);
        Integer code = (Integer) entries.get("code");
        Assert.isTrue(code.equals(0), String.valueOf(entries.get("message")));
        return entries;
    }
}
