package com.zswl.cloud.springBtach.server.core.config;

import cn.hutool.core.lang.Snowflake;
import cn.hutool.core.util.IdUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.cloud.client.ServiceInstance;
import org.springframework.cloud.client.discovery.DiscoveryClient;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import java.util.List;

@Configuration
public class SnowFlakeConfig {
    @Autowired
    DiscoveryClient discoveryClient;

    @Value("${spring.application.name}")
    private String applicationName;


    @Bean
    public Snowflake snowflake(){

        List<ServiceInstance> instances = discoveryClient.getInstances(applicationName);

        return IdUtil.getSnowflake(instances.size());
    }

}
