package com.zswl.cloud.springBtach.server.core.controller;


import com.github.microservice.auth.client.constant.AuthConstant;
import com.github.microservice.auth.client.content.ResultContent;
import com.github.microservice.auth.security.annotations.ResourceAuth;
import com.github.microservice.auth.security.type.AuthType;
import com.zhongshu.payment.client.model.order.v2.CreatOrderResultModel;
import com.zswl.cloud.springBatch.client.model.dfy.Hotel.request.*;
import com.zswl.cloud.springBatch.client.model.dfy.Hotel.response.*;
import com.zswl.cloud.springBatch.client.service.DfyHotelService;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.validation.Valid;

@Log4j2
@RestController
@RequestMapping("dfy/hotel")
public class DfyHotelController {

    @Autowired
    DfyHotelService dfyHotelService;

    @ApiOperation(" 目的地搜索")
    @RequestMapping(value = "queryNew", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    @ResourceAuth(value = AuthConstant.User, type = AuthType.User)
    ResultContent<QueryNewResponse> queryNew(@RequestBody QueryNewRequest queryNewRequest) {
        return dfyHotelService.queryNew(queryNewRequest);
    }


    @ApiOperation(" 酒店搜索接口")
    @RequestMapping(value = "hotelList", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    @ResourceAuth(value = AuthConstant.User, type = AuthType.User)
    ResultContent<HotelListResponse> hotelList(@RequestBody HotelListRequest hotelListRequest) {
        return dfyHotelService.hotelList(hotelListRequest);
    }


    @ApiOperation(" 酒店详情接口")
    @RequestMapping(value = "hotelDetail", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    @ResourceAuth(value = AuthConstant.User, type = AuthType.User)
    ResultContent<HotelDetailResponse> hotelDetail(@RequestBody HotelDetailRequest hotelDetailRequest) {
        return dfyHotelService.hotelDetail(hotelDetailRequest);
    }


    @ApiOperation(" 房型及报价查询接口")
    @RequestMapping(value = "ratePlanInfo", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    @ResourceAuth(value = AuthConstant.User, type = AuthType.User)
    ResultContent<RatePlanInfoResponse> ratePlanInfo(@RequestBody RatePlanInfoRequest ratePlanInfoRequest) {
        return dfyHotelService.ratePlanInfo(ratePlanInfoRequest);
    }


    @ApiOperation(" 实时询价接口")
    @RequestMapping(value = "ratePlan", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    @ResourceAuth(value = AuthConstant.User, type = AuthType.User)
    ResultContent<RatePlanResponse> ratePlan(@RequestBody RatePlanRequest ratePlanRequest) {
        return dfyHotelService.ratePlan(ratePlanRequest);
    }


    @ApiOperation(" 创建订单接口")
    @RequestMapping(value = "addOrder", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    @ResourceAuth(value = AuthConstant.User, type = AuthType.User)
    ResultContent<CreatOrderResultModel> addOrder(@RequestBody @Valid AddOrderRequest addOrderRequest) {
        return dfyHotelService.addOrder(addOrderRequest);
    }

    @ApiOperation(" 订单详情接口")
    @RequestMapping(value = "orderDetail", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    @ResourceAuth(value = AuthConstant.User, type = AuthType.User)
    ResultContent<OrderDetailResponse> orderDetail(@RequestBody OrderDetailRequest orderDetailRequest) {
        return dfyHotelService.orderDetail(orderDetailRequest);
    }


    @ApiOperation(" 付款(代扣)接口")
    @RequestMapping(value = "submitOrder", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    @ResourceAuth(value = AuthConstant.SuperAdmin, type = AuthType.Enterprise)
    ResultContent<SubmitOrderResponse> submitOrder(@RequestBody SubmitOrderRequest submitOrderRequest) {
        return dfyHotelService.submitOrder(submitOrderRequest);
    }


    @ApiOperation(" 取消订单接口")
    @RequestMapping(value = "cancelOrder", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE)
    @ResourceAuth(value = AuthConstant.User, type = AuthType.User)
   public ResultContent<CancelOrderResponse> cancelOrder(@RequestBody CancelOrderRequest cancelOrderRequest) {
        return dfyHotelService.cancelOrder(cancelOrderRequest);
    }

}
