package com.zswl.cloud.springBtach.server.core.controller;

import cn.hutool.json.JSONObject;
import com.github.microservice.auth.client.content.ResultContent;
import com.github.microservice.auth.security.annotations.ResourceAuth;
import com.github.microservice.auth.security.type.AuthType;
import com.zhongshu.payment.client.model.order.v2.CreatOrderResultModel;
import com.zswl.cloud.springBatch.client.model.ypp.kfc.request.CreateOrdereRquest;
import com.zswl.cloud.springBatch.client.model.ypp.kfc.response.CityListResponse;
import com.zswl.cloud.springBatch.client.model.ypp.kfc.response.CreateOrdereResponse;
import com.zswl.cloud.springBatch.client.model.ypp.kfc.response.ShopResponse;
import com.zswl.cloud.springBatch.client.model.ypp.kfc.response.ShopsResponse;
import com.zswl.cloud.springBtach.server.core.api.ypp.request.KfcGoodsDetailRequest;
import com.zswl.cloud.springBtach.server.core.api.ypp.request.KfcShopDetailRequest;
import com.zswl.cloud.springBtach.server.core.api.ypp.request.KfcShopsRequest;
import com.zswl.cloud.springBtach.server.core.service.impl.KfcServiceImpl;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.websocket.server.PathParam;

@Log4j2
@RestController
@RequestMapping("ypp/kfc")
public class KfcController {

    @Autowired
    private KfcServiceImpl kfcService;

    @ApiOperation("城市列表")
    @ResourceAuth(value = "user", type = AuthType.User)
    @RequestMapping(value = "cityList", method = RequestMethod.GET)
    public ResultContent<CityListResponse> cityList() {

        return kfcService.cityList();
    }

    @ApiOperation("平台店铺列表")
    @ResourceAuth(value = "user", type = AuthType.User)
    @RequestMapping(value = "shops", method = RequestMethod.POST)
    public ResultContent<ShopsResponse> shops(@RequestBody KfcShopsRequest kfcShopsRequest) {
        return kfcService.shops(kfcShopsRequest);
    }

    @ApiOperation("店铺详情")
    @ResourceAuth(value = "user", type = AuthType.User)
    @RequestMapping(value = "shop", method = RequestMethod.POST)
    public ResultContent<ShopResponse> shop(@RequestBody KfcShopDetailRequest kfcShopsRequest) {
        return kfcService.shop(kfcShopsRequest);
    }

    @ApiOperation("店铺详情")
    @ResourceAuth(value = "user", type = AuthType.User)
    @RequestMapping(value = "menus/{shopId}", method = RequestMethod.GET)
    public ResultContent<JSONObject> menus(@PathVariable("shopId") String shopId) {
        return kfcService.menus(shopId);
    }

    @ApiOperation("商品详情(不同平台返回的商品详情会有所不同)")
    @ResourceAuth(value = "user", type = AuthType.User)
    @RequestMapping(value = "goodsDetail", method = RequestMethod.POST)
    public ResultContent<JSONObject> goodsDetail(@RequestBody KfcGoodsDetailRequest kfcGoodsDetailRequest) {
        return kfcService.goodsDetail(kfcGoodsDetailRequest);
    }

    @ApiOperation("下单(自己做产品展示，才需要下单接口)")
    @ResourceAuth(value = "user", type = AuthType.User)
    @RequestMapping(value = "createOrder", method = RequestMethod.POST)
    public ResultContent<CreatOrderResultModel> createOrder(@RequestBody CreateOrdereRquest createOrdereRquest) {
        return kfcService.createOrder(createOrdereRquest);
    }
}
