package com.zswl.cloud.springBtach.server.core.controller;

import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.xiaoju.open.oil.commons.OilRequest;
import com.xiaoju.open.oil.core.executor.ResponseDTO;
import com.zhongshu.payment.client.model.order.v2.UpdateGoodsModel;
import com.zhongshu.payment.client.service.v2.OrderService2;
import com.zswl.cloud.springBatch.client.model.dfy.Ticket.request.OrderDetailRequest;
import com.zswl.cloud.springBatch.client.model.dfy.pub.SyncRequest;
import com.zswl.cloud.springBtach.server.core.api.video.YqdSyncOrderModel;
import com.zswl.cloud.springBtach.server.core.api.ypp.request.SyncOrderRequest;
import com.zswl.cloud.springBtach.server.core.dao.ApiLogDao;
import com.zswl.cloud.springBtach.server.core.domain.ApiLog;
import com.zswl.cloud.springBtach.server.core.service.YppService;
import com.zswl.cloud.springBtach.server.core.service.impl.XiaoJuServiceImpl;
import com.zswl.cloud.springBtach.server.core.service.impl.DfyHotelServiceImpl;
import com.zswl.cloud.springBtach.server.core.service.impl.DfyTicketServiceImpl;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

@Log4j2
@RestController
@RequestMapping("sync")
public class SycController {

    @Autowired
    XiaoJuServiceImpl xiaoJuService;

    @Autowired
    ApiLogDao apiLogDao;

    @Autowired
    OrderService2 orderService2;

    @Autowired
    DfyTicketServiceImpl dfyTicketService;

    @Autowired
    DfyHotelServiceImpl dfyHotelService;

    @Autowired
    YppService yppService;


    @ApiOperation("推送-同步订单信息")
    @RequestMapping(value = "xiaoju/notifyOrderInfo", method = RequestMethod.POST)
    public ResponseDTO notifyOrderInfo(@RequestBody OilRequest oilRequest) {

        return xiaoJuService.notifyOrderInfo(oilRequest);
    }

    @ApiOperation("推送-同步加油站信息")
    @RequestMapping(value = "xiaoju/receivingGasStation", method = RequestMethod.POST)
    public ResponseDTO receivingGasStation(@RequestBody OilRequest oilRequest) {

        return xiaoJuService.notificationPushStoreInfoRequest(oilRequest);
    }

    @ApiOperation("同步视频会员支付状态")
    @RequestMapping(value = "yqd/orderState", method = RequestMethod.POST)
    public String receivingGasStation(@RequestBody YqdSyncOrderModel yqdSyncOrderModel) {

        if (!yqdSyncOrderModel.getStatus().equals(4)) {
            UpdateGoodsModel updateGoodsModel = new UpdateGoodsModel();
            updateGoodsModel.setId(yqdSyncOrderModel.getExternalOrderno());
            updateGoodsModel.setDelivery(false);
            orderService2.updateGoods(updateGoodsModel);
        }
        ApiLog apiLog = new ApiLog();
        apiLog.setSystem("video");
        apiLog.setRequest(JSONUtil.toJsonStr(yqdSyncOrderModel));
        apiLog.setService("syncOrderState");
        apiLog.setResponse("ok");
        apiLogDao.save(apiLog);
        return "ok";
    }


    @ApiOperation("dfy订单同步")
    @RequestMapping(value = "dfy/orderState", method = RequestMethod.POST)
    public JSONObject dfyOrderState(@RequestBody SyncRequest syncRequest) {
        ApiLog apiLog = new ApiLog();
        apiLog.setSystem("dfy");
        apiLog.setRequest(JSONUtil.toJsonStr(syncRequest));
        apiLog.setService("sync");
        JSONObject entries = new JSONObject();
        entries.set("success", true);
        entries.set("msg", "成功执行");
        entries.set("errorCode", 200);
        apiLog.setResponse(JSONUtil.toJsonStr(entries));
        apiLogDao.save(apiLog);


        switch (syncRequest.getApiKey()) {
            case "248186_Ticket":
                OrderDetailRequest orderDetailRequest = new OrderDetailRequest();
                orderDetailRequest.setOrderId(syncRequest.getData().getOrderId());
                dfyTicketService.orderDetail(orderDetailRequest);

                break;
            case "248186_DomesticHotel":
                com.zswl.cloud.springBatch.client.model.dfy.Hotel.request.OrderDetailRequest orderDetailRequest1 = new com.zswl.cloud.springBatch.client.model.dfy.Hotel.request.OrderDetailRequest();
                orderDetailRequest1.setOrderId(syncRequest.getData().getOrderId());
                dfyHotelService.orderDetail(orderDetailRequest1);
                break;

        }


        return entries;
    }

    @ApiOperation("ypp订单同步")
    @RequestMapping(value = "ypp/orderState", method = RequestMethod.POST)
    public String yppOrderState(@RequestBody SyncOrderRequest syncRequest) {
        yppService.syncOrderState(syncRequest);
        return "成功";
    }
}
