package com.zswl.cloud.springBtach.server.core.dao.Impl;

import com.zswl.cloud.springBatch.client.model.request.NearbyModel;
import com.zswl.cloud.springBatch.client.model.request.XiaoJuStoreModel;
import com.zswl.cloud.springBtach.server.core.dao.extend.XiaoJuStoreDaoExtend;
import com.zswl.cloud.springBtach.server.core.domain.XiaoJuStore;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.geo.*;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.NearQuery;

import java.util.ArrayList;
import java.util.List;

public class XiaoJuStoreDaoImpl implements XiaoJuStoreDaoExtend {


    @Autowired
    MongoTemplate mongoTemplate;

    public List<XiaoJuStoreModel> findNearbyTargets(NearbyModel nearbyModel) {
        Point point = new Point(nearbyModel.getLongitude(), nearbyModel.getLatitude());
        NearQuery query = NearQuery.near(point).maxDistance(new Distance(nearbyModel.getMaxDistanceInKilometers(), Metrics.KILOMETERS));
        GeoResults<XiaoJuStore> results = mongoTemplate.geoNear(query, XiaoJuStore.class);

        List<XiaoJuStoreModel> nearbyTargets = new ArrayList<>();
        for (GeoResult<XiaoJuStore> result : results) {
            XiaoJuStoreModel xiaoJuStoreModel = new XiaoJuStoreModel();
            BeanUtils.copyProperties(result.getContent(), xiaoJuStoreModel);
            xiaoJuStoreModel.setDistance(result.getDistance());
            nearbyTargets.add(xiaoJuStoreModel);
        }
        return nearbyTargets;
    }


}
