package com.zswl.cloud.springBtach.server.core.domain;

import com.github.microservice.components.data.mongo.mongo.domain.SuperEntity;
import com.xiaoju.open.oil.interfaces.domain.ItemPriceInfoForCallback;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.data.mongodb.core.index.GeoSpatialIndexType;
import org.springframework.data.mongodb.core.index.GeoSpatialIndexed;
import org.springframework.data.mongodb.core.index.Indexed;
import org.springframework.data.mongodb.core.mapping.Document;

import java.util.List;

@Data
@Builder
@Document
@AllArgsConstructor
@NoArgsConstructor
public class XiaoJuStore extends SuperEntity {


    @Indexed(unique = true)
    private String storeId;
    private String storeName;
    private String address;
    private Float lat;
    private Float lon;

    @GeoSpatialIndexed
    private double[] location;
    private String cityName;
    private String brandId;
    private String provinceName;
    private String brandName;
    private String tel;
    private String openTimeHourStart;
    private String openTimeHourEnd;
    private String logo;
    private List<String> picList;
    private Integer status;
    private Integer invoiceManner;
    private List<String> marketTags;
    private List<ItemPriceInfoForCallback> itemInfoList;
}
