package com.zswl.cloud.springBtach.server.core.job.standard;

import com.github.microservice.auth.client.content.ResultContent;
import com.zhongshu.payment.client.model.payment.zswl.CreatePayment2Model;
import com.zhongshu.payment.client.service.v2.PaymentService2;
import lombok.Data;
import lombok.extern.log4j.Log4j2;
import org.springframework.batch.core.Job;
import org.springframework.batch.core.Step;
import org.springframework.batch.core.configuration.annotation.JobBuilderFactory;
import org.springframework.batch.core.configuration.annotation.StepBuilderFactory;
import org.springframework.batch.core.launch.support.RunIdIncrementer;
import org.springframework.batch.repeat.RepeatStatus;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import javax.annotation.Resource;

@Data
@Configuration
@Log4j2
public class StandarPayJob {

    ThreadLocal<ResultContent> resultContent = new ThreadLocal<>();
    ThreadLocal<CreatePayment2Model> parameter = new ThreadLocal<>();
    @Resource
    private JobBuilderFactory jobBuilderFactory;
    @Resource
    private StepBuilderFactory stepBuilderFactory;

    @Autowired
    PaymentService2 paymentService2;


    public Step standardPaymentStep() {
        return stepBuilderFactory.get("standardPaymentStep")
                .tasklet((contribution, chunkContext) -> {
                    resultContent.set(paymentService2.creatPayOrder(parameter.get()));
                    return RepeatStatus.FINISHED;
                })
                .build();
    }

    @Bean
    public Job standarPay() {
        return getJobBuilderFactory()
                .get("standarPayJob")
                .start(standardPaymentStep())
                .incrementer(new RunIdIncrementer())
                .build();
    }


}
