package com.zswl.cloud.springBtach.server.boot;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.alibaba.fastjson.JSON;
import com.github.microservice.auth.client.content.ResultContent;
import com.github.microservice.auth.client.service.EnterpriseService;
import com.github.microservice.core.util.net.apache.ResponseModel;
import com.github.microservice.productcenter.client.model.LocationModel;
import com.github.microservice.productcenter.client.model.ProductPushModel;
import com.github.microservice.productcenter.client.stream.ProductCenterStream;
import com.github.microservice.productcenter.client.type.ProductType;
import com.xiaoju.open.oil.commons.config.OilConfig;
import com.xiaoju.open.oil.core.QueryClient;
import com.xiaoju.open.oil.core.QueryClientFactory;
import com.xiaoju.open.oil.interfaces.domain.AllowancePromotionInfo;
import com.xiaoju.open.oil.interfaces.domain.GenPromotionInfo;
import com.xiaoju.open.oil.interfaces.request.QueryGetPromotionRequest;
import com.xiaoju.open.oil.interfaces.request.QueryOrderPromotionListRequest;
import com.xiaoju.open.oil.interfaces.request.miniprogram.MiniProgramQueryNewOrderRequest;
import com.xiaoju.open.oil.interfaces.request.miniprogram.MiniQueryCalPriceRequest;
import com.xiaoju.open.oil.interfaces.response.miniprogram.MiniQueryCalPriceResponse;
import com.xiaoju.open.oil.interfaces.response.miniprogram.MiniQueryNewOrderResponse;
import com.zhongshu.payment.client.model.order.v2.GoodsResultModel;
import com.zhongshu.payment.client.model.order.v2.OrderResult2Model;
import com.zhongshu.payment.client.model.order.v2.UserSeachOrder2Model;
import com.zhongshu.payment.client.service.v2.OrderService2;
import com.zhongshu.payment.client.service.v2.PaymentService2;
import com.zhongshu.payment.client.type.Channel;
import com.zswl.cloud.shop.client.service.GoodsService;
import com.zswl.cloud.shop.client.service.ShopService;
import com.zswl.cloud.shop.client.vo.yqd.CatalogVo;
import com.zswl.cloud.shop.client.vo.yqd.CommodityVo;
import com.zswl.cloud.springBatch.client.model.dfy.Hotel.request.HotelListRequest;
import com.zswl.cloud.springBatch.client.model.dfy.Hotel.request.QueryNewRequest;
import com.zswl.cloud.springBatch.client.model.dfy.Hotel.request.SubmitOrderRequest;
import com.zswl.cloud.springBatch.client.model.dfy.Hotel.response.AddOrderResponse;
import com.zswl.cloud.springBatch.client.model.dfy.Hotel.response.HotelListResponse;
import com.zswl.cloud.springBatch.client.model.dfy.Hotel.response.QueryNewResponse;
import com.zswl.cloud.springBatch.client.model.dfy.Hotel.response.SubmitOrderResponse;
import com.zswl.cloud.springBatch.client.service.DfyHotelService;
import com.zswl.cloud.springBtach.server.core.api.dfy.DomesticHotelApi;
import com.zswl.cloud.springBtach.server.core.api.dfy.TicketApi;
import com.zswl.cloud.springBtach.server.core.api.qiuxiang.QiuXiangApi;
import com.zswl.cloud.springBtach.server.core.api.video.YqdServiceImpl;
import com.zswl.cloud.springBtach.server.core.api.ypp.KfcApi;
import com.zswl.cloud.springBtach.server.core.api.ypp.YppApi;
import com.zswl.cloud.springBtach.server.core.controller.TestSpringBatch;
import com.zswl.cloud.springBtach.server.core.dao.XiaoJuActivityReceiverDao;
import com.zswl.cloud.springBtach.server.core.service.PaymentService;
import com.zswl.cloud.springBtach.server.core.service.impl.DfyTicketServiceImpl;
import com.zswl.cloud.springBtach.server.core.service.impl.OrderServiceImpl;
import com.zswl.cloud.springBtach.server.core.service.impl.RechargeServiceImpl;
import com.zswl.cloud.springBtach.server.core.service.impl.XiaoJuServiceImpl;
import lombok.extern.log4j.Log4j2;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.data.domain.Page;
import org.springframework.data.mongodb.core.MongoTemplate;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@SpringBootTest
@Log4j2
public class ServerApplicationTests {
    @Autowired
    YppApi piaoPiaoApi;

    @Autowired
    TestSpringBatch testSpringBatch;

    @Autowired
    OrderServiceImpl orderService;


    @Autowired
    EnterpriseService enterpriseService;

    @Autowired
    PaymentService2 paymentService2;


    @Autowired
    PaymentService paymentService;

    @Autowired
    QiuXiangApi qiuXiangApi;

    @Autowired
    TicketApi diFengYunApi;

    @Autowired
    YqdServiceImpl yqdService;


    @Autowired
    RechargeServiceImpl rechargeService;

    @Autowired
    ProductCenterStream productCenterStream;

    @Autowired
    DfyHotelService dfyHotelService;
    @Autowired
    private XiaoJuServiceImpl xiaoJuServiceImpl;
    @Autowired
    private XiaoJuActivityReceiverDao xiaoJuActivityReceiverDao;
    @Autowired
    private KfcApi kfcApi;
    @Autowired
    private YppApi yppApi;


    @Test
    public void dfy() throws Exception {
        for (CatalogVo catalogVo : yqdService.getCatalog()) {
            ResponseModel responseModel = yqdService.requestCommodityList("0", "100", catalogVo.getId());
            JSONObject entries = JSONUtil.parseObj(responseModel.getBody());
            JSONArray jsonArray = (JSONArray) entries.get("data");
            if (!jsonArray.isEmpty()) {
                List<CommodityVo> commodityVos = com.alibaba.fastjson.JSONArray.parseArray(JSON.toJSONString(jsonArray), CommodityVo.class);
                commodityVos.forEach(it -> {

                    Integer mainId = it.getMainId();
                    String mainImg = it.getMainImg();
                    String name = it.getName();
                    BigDecimal price = it.getPrice();
                    BigDecimal rate = price.multiply(new BigDecimal("0.06"));
                    BigDecimal withdraw = price.add(rate).multiply(new BigDecimal("0.0028"));
                    price = price.add(rate).add(withdraw).setScale(2, RoundingMode.UP);


                    System.out.println(mainId);
                    System.out.println(mainImg);
                    System.out.println(name);
                    System.out.println(price);

                });
                System.out.println(commodityVos);
            }

        }
    }


    @Autowired
    DomesticHotelApi domesticHotelApi;

    @Test
    public void hotel() {
//        CancelOrderRequest cancelOrderRequest = new CancelOrderRequest();
//        cancelOrderRequest.setOrderId("1248207159");
//
//        CancelOrderResponse cancelOrderResponse = domesticHotelApi.cancelOrder(cancelOrderRequest);
//        System.out.println(JSONUtil.toJsonStr(cancelOrderResponse));


        orderService2.orderInfo("1798294662177759232");
        ResultContent<List<GoodsResultModel>> listResultContent = orderService2.goodsDetail("1798294662177759232");
        GoodsResultModel goodsResultModel = listResultContent.getContent().get(0);
        BigDecimal payAmount = goodsResultModel.getPayAmount();

        AddOrderResponse.Datas bean = JSONUtil.toBean(goodsResultModel.getExtend(), AddOrderResponse.Datas.class);


        SubmitOrderRequest submitOrderRequest = new SubmitOrderRequest();
        submitOrderRequest.setOrderId(bean.getOrderId());
        submitOrderRequest.setPayType(1);
        submitOrderRequest.setPay(String.valueOf(payAmount));

        SubmitOrderResponse submitOrderResponse = domesticHotelApi.submitOrder(submitOrderRequest);
        System.out.println(submitOrderResponse);
    }


    @Autowired
    ShopService shopService;

    @Test
    public void test3() {
        String name = "贵阳";
        QueryNewRequest queryNewRequest = new QueryNewRequest();
        queryNewRequest.setKeywords(name);
        QueryNewResponse queryNewResponse = domesticHotelApi.queryNew(queryNewRequest);
        QueryNewResponse.Datas data = queryNewResponse.getData();
        List<QueryNewResponse.Dest> destinationSuggests = data.getDestinationSuggests();
        for (QueryNewResponse.Dest dest : destinationSuggests.stream().filter(it -> !it.getPoiType().equals(Integer.valueOf(7))).collect(Collectors.toList())) {
            int start = 0;
            int limit = 30;
            log.info("地区：", dest);

            while (true) {
                HotelListRequest hotelListRequest = new HotelListRequest();
                hotelListRequest.setStart(start);
                hotelListRequest.setLimit(limit);
                hotelListRequest.setCityName(dest.getCityName());
                hotelListRequest.setCityCode(dest.getCityCode());
                Date date = new Date();
                String inDate = DateUtil.format(date, "yyyy-MM-dd");
                DateTime dateTime = DateUtil.offsetDay(date, 1);
                long time = dateTime.getTime();
                String oute = DateUtil.format(new Date(time), "yyyy-MM-dd");
                hotelListRequest.setCheckInDate(inDate);
                hotelListRequest.setCheckOutDate(oute);
                HotelListRequest.FilterInfo filterInfo = new HotelListRequest.FilterInfo();
                hotelListRequest.setFilter(filterInfo);


                HotelListResponse hotelListResponse = domesticHotelApi.hotelList(hotelListRequest);
                if (!hotelListResponse.getSuccess()) {
                    return;
                }
                HotelListResponse.Datas data1 = hotelListResponse.getData();
                if (data1.getHotelList().isEmpty()) {
                    return;
                }
                data1.getHotelList().forEach(it -> {
                            System.out.println(it);
                            try {
                                String hotelId = it.getHotelId();
                                String chineseName = it.getChineseName();
                                String picture = it.getPicture();
                                BigDecimal price = it.getPrice();
                                Double latitude = it.getLatitude();
                                Double longitude = it.getLongitude();
                                LocationModel locationModel = new LocationModel(longitude, latitude);
                                productCenterStream.send(List.of(ProductPushModel.builder()
                                        .regionCode("520101")
                                        .pid(hotelId)
                                        .productType(ProductType.Hotel)
                                        .cover(new String[]{picture})
                                        .salePrice(price.longValue())
                                        .title(chineseName)
                                        .meta(Map.of("hotel", it))
                                        .locationPoint(locationModel)
//                            .expireTimeSecond(60 * 60 * 24)
                                        .build()));
                            } catch (Exception e) {
                                e.printStackTrace();
                            }


                        }
                );

                start += limit;
            }

        }

    }


    @Autowired
    GoodsService goodsService;

    @Autowired
    OrderService2 orderService2;
    @Autowired
    MongoTemplate mongoTemplate;


    @Autowired
    OilConfig oilConfig;

    @Test
    public void queryNewOrderq1() {
        MiniProgramQueryNewOrderRequest newOrderRequest = new MiniProgramQueryNewOrderRequest();
        newOrderRequest.setStoreId("5154031457384536897");
        newOrderRequest.setGunNo("2");
        newOrderRequest.setLat(30.280486F);
        newOrderRequest.setLon(120.094503F);
        newOrderRequest.setLitre(13450);
        newOrderRequest.setOpenChannel(1);
        newOrderRequest.setOrderAmount(10000);
        newOrderRequest.setRealAmount(7708);
        newOrderRequest.setOutOrderId("13232344343");
        newOrderRequest.setOutUserId("65fe583d74d67a7dbd842b45");
        newOrderRequest.setServiceFee(312);
        newOrderRequest.setItemId(4879454965524071453L);
        newOrderRequest.setMobile("13368172379");

        com.xiaoju.open.oil.interfaces.domain.AllowanceInfo allowanceInfo = new com.xiaoju.open.oil.interfaces.domain.AllowanceInfo();

        newOrderRequest.setPromotionInfo(List.of());


        QueryClient queryClient = QueryClientFactory.create(oilConfig);
        MiniQueryNewOrderResponse response = queryClient.apiMini().queryNewOrder(newOrderRequest);
        System.out.println(response);

    }

    // 下单前查询最优可用券
    @Test
    public void queryOrderPromotionList() {
        QueryOrderPromotionListRequest request = new QueryOrderPromotionListRequest();
        request.setOutUserId("80200281708");
        request.setStoreId("5429504232738269218");
        request.setAllowanceType(2);
        request.setOrderAmount(24500);

        QueryClient queryClient = QueryClientFactory.create(oilConfig);
        List<AllowancePromotionInfo> response = queryClient.promotion().queryOrderPromotionList(request);
        System.out.println(response);
    }


    // 券发放
    @Test
    public void getPromotion() {
        QueryGetPromotionRequest request = new QueryGetPromotionRequest();
        request.setOutUserId("18874");
        request.setActivityId("872933491179388928");
        request.setTradeNo("2202071307003069990");

        QueryClient queryClient = QueryClientFactory.create(oilConfig);
        List<GenPromotionInfo> response = queryClient.promotion().getPromotion(request);
        System.out.println(response);
    }

    @Test
    public void queryCalPrice() {
        MiniQueryCalPriceRequest calPriceRequest = new MiniQueryCalPriceRequest();
        calPriceRequest.setStoreId("5429780558166639664");
        calPriceRequest.setAmount(10000);
        calPriceRequest.setItemName("92#");
        calPriceRequest.setOpenChannel(1);
        calPriceRequest.setOutUserId("65fe583d74d67a7dbd842b45");

        QueryClient queryClient = QueryClientFactory.create(oilConfig);
        MiniQueryCalPriceResponse response = queryClient.apiMini().queryCalPrice(calPriceRequest);
        System.out.println(JSONUtil.toJsonStr(response));

    }

    @Test
    public void queryNewOrder() {
        MiniProgramQueryNewOrderRequest newOrderRequest = new MiniProgramQueryNewOrderRequest();
        newOrderRequest.setStoreId("5154031457384536897");
        newOrderRequest.setOutUserId("1640563200");
        newOrderRequest.setMobile("13368172379");
        newOrderRequest.setGunNo("2");
        newOrderRequest.setLat(30.280486F);
        newOrderRequest.setLon(120.094503F);
        newOrderRequest.setLitre(13450);
        newOrderRequest.setOpenChannel(1);
        newOrderRequest.setOrderAmount(10000);
        newOrderRequest.setRealAmount(7708);
        newOrderRequest.setOutOrderId("13232344343");
        newOrderRequest.setServiceFee(312);
        newOrderRequest.setItemId(4879454965524071453L);
        QueryClient queryClient = QueryClientFactory.create(oilConfig);
        MiniQueryNewOrderResponse response = queryClient.apiMini().queryNewOrder(newOrderRequest);

    }

    @Autowired
    DfyTicketServiceImpl dfyTicketService;

    @Test
    public void sync() {
        UserSeachOrder2Model userSeachOrder2Model = new UserSeachOrder2Model();
        userSeachOrder2Model.setChannel(Channel.ZhongShu);
        userSeachOrder2Model.setUserId("660a534e32e63427d1a09c2a");
        ResultContent<Page<OrderResult2Model>> pageResultContent = orderService2.userSearch(userSeachOrder2Model);
        System.out.println(JSONUtil.toJsonStr(pageResultContent));
    }


}
